Index: trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.cpp	(revision 42061)
+++ trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.cpp	(revision 42340)
@@ -171,22 +171,22 @@
     LogFlow(("Destroying FFmpegFB object %p\n", this));
 #ifdef VBOX_WITH_VPX
-	/* Dummy update to make sure we get all the frame (timing). */
+    /* Dummy update to make sure we get all the frame (timing). */
     NotifyUpdate(0, 0, 0, 0);
     /* Write the last pending frame before exiting */
     int rc = do_rgb_to_yuv_conversion();
     if (rc == S_OK)
-		do_encoding_and_write();
+        do_encoding_and_write();
 # if 1
     /* Add another 10 seconds. */
     for (int i = 10*25; i > 0; i--)
-		do_encoding_and_write();
+        do_encoding_and_write();
 # endif
     Ebml_WriteWebMFileFooter(&ebml, 0);
-	if(ebml.stream)
-	    fclose(ebml.stream);
+    if(ebml.stream)
+        fclose(ebml.stream);
     vpx_codec_destroy(&mVpxCodec);
     RTCritSectDelete(&mCritSect);
 
-	/* We have already freed the stream above */
+    /* We have already freed the stream above */
     if (mTempRGBBuffer != 0)
         free(mTempRGBBuffer);
@@ -265,10 +265,10 @@
     if (mOutOfMemory == true)
         return E_OUTOFMEMORY;
-	int rc;
-	int rcOpenFile;
-	int rcOpenCodec;
+    int rc;
+    int rcOpenFile;
+    int rcOpenCodec;
 
 #ifdef VBOX_WITH_VPX
-	mFrameCount = 0;
+    mFrameCount = 0;
     memset(&ebml, 0, sizeof(struct EbmlGlobal));
     ebml.last_pts_ms = -1;
@@ -837,11 +837,11 @@
 {
 #ifdef VBOX_WITH_VPX
-	vpx_codec_err_t      res;
+    vpx_codec_err_t      res;
     /* Populate encoder configuration */
     if ((res = vpx_codec_enc_config_default(interface, &mVpxConfig, 0)))
-	{
-		LogFlow(("Failed to configure codec \n"));
+    {
+        LogFlow(("Failed to configure codec \n"));
         AssertReturn(res == 0, E_UNEXPECTED);
-	}
+    }
 
     mVpxConfig.rc_target_bitrate = 512;
@@ -850,5 +850,5 @@
     mVpxConfig.g_timebase.den = 30;
     mVpxConfig.g_timebase.num = 1;
-	mVpxConfig.g_threads = 8;
+    mVpxConfig.g_threads = 8;
 
     vpx_rational ebmlFPS = mVpxConfig.g_timebase;
@@ -916,11 +916,11 @@
     char szFileName[RTPATH_MAX];
     strcpy(szFileName, com::Utf8Str(mFileName).c_str());
-	ebml.stream = fopen(szFileName, "wb");
-	if (!ebml.stream)
-	{
-		LogFlow(("Failed to open the output File \n"));
+    ebml.stream = fopen(szFileName, "wb");
+    if (!ebml.stream)
+    {
+        LogFlow(("Failed to open the output File \n"));
         return E_FAIL;
-	}
-	return S_OK;
+    }
+    return S_OK;
 #else
     char szFileName[RTPATH_MAX];
@@ -1109,15 +1109,15 @@
     if (mYUVBuffer != NULL)
     {
-		AssertReturn(VpxRawImage.w*VpxRawImage.h*3/2 <= sizeof(mYUVFrameSize), E_UNEXPECTED);
-		memcpy(VpxRawImage.planes[0], (uint8_t *)mYUVBuffer, VpxRawImage.w*VpxRawImage.h*3/2);
-    }
-
-	if ((res = vpx_codec_encode(&mVpxCodec, &VpxRawImage , mFrameCount,
+        AssertReturn(VpxRawImage.w*VpxRawImage.h*3/2 <= sizeof(mYUVFrameSize), E_UNEXPECTED);
+        memcpy(VpxRawImage.planes[0], (uint8_t *)mYUVBuffer, VpxRawImage.w*VpxRawImage.h*3/2);
+    }
+
+    if ((res = vpx_codec_encode(&mVpxCodec, &VpxRawImage , mFrameCount,
                   mDuration, 0, VPX_DL_REALTIME)))
-	{
+    {
         LogFlow(("Failed to encode: %s\n", vpx_codec_err_to_string(res)));
-		AssertReturn(res != 0, E_UNEXPECTED);
-
-	}
+        AssertReturn(res != 0, E_UNEXPECTED);
+
+    }
     while ((pkt = vpx_codec_get_cx_data(&mVpxCodec, &iter)))
     {
Index: trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.h
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.h	(revision 42061)
+++ trunk/src/VBox/Frontends/VBoxHeadless/VideoCapture/FFmpegFB.h	(revision 42340)
@@ -103,10 +103,10 @@
 private:
 #ifdef VBOX_WITH_VPX
-	EbmlGlobal ebml;
-	vpx_codec_ctx_t      mVpxCodec;
+    EbmlGlobal ebml;
+    vpx_codec_ctx_t      mVpxCodec;
     vpx_codec_enc_cfg_t  mVpxConfig;
-	FILE * mOutputFile;
-	unsigned long mDuration;
-	uint32_t  mFrameCount;
+    FILE * mOutputFile;
+    unsigned long mDuration;
+    uint32_t  mFrameCount;
 
 #else
@@ -118,5 +118,5 @@
     AVFrame *mFrame;
 
-	HRESULT setup_library();
+    HRESULT setup_library();
     HRESULT setup_output_format();
     HRESULT list_formats();